#include "testlib.h"
#include <algorithm>
using namespace std;

const int MAXN = (int)2e5;
const int MAX_LEN = 5 * (int)1e5;
vector<int> st; //stack
bool isChild[MAXN];
vector<std::pair<int, int> > ans_;

struct Node {
    Node *nxt[26];
    vector<int> ends;
    Node() {
        for (int i = 0; i < 26; i++) {
            nxt[i] = NULL;
        }
    }
};

void dfs(Node *vert) {
    for (int i = 0; i < (int)(vert->ends.size()); i++) {
        st.push_back(vert->ends[i]);
    }

    for (int i = 0; i < 26; i++) {
        Node *child = vert->nxt[i];
        if (child != NULL) {
            dfs(child);
        }
    }

    for (int i = 0; i < (int)(vert->ends.size()); i++) {
        isChild[vert->ends[i]] = true;
    }
    while (st.size() > 1 && isChild[st.back()]) {
        int num1 = st.back();
        st.pop_back();
        int num2 = st.back();
        st.pop_back();
        ans_.push_back(make_pair(num1, num2));
    }
    if (st.size() == 1 && isChild[st.back()]) {
		st.pop_back();
	}
    for (int i = 0; i < (int)(vert->ends.size()); i++) {
        isChild[vert->ends[i]] = false;
    }
}

int main(int argc, char **argv) 
{
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();

    int sz = 0;
    Node *root = new Node();
    for (int i = 0; i < 2 * n; i++)
    {
        string str = inf.readLine();
        sz += str.size();

        Node *node = root;
        for (int j = 0; j < (int)str.size(); j++) {
            ensuref(str[j] >= 'a' && str[j] <= 'z', "Incorrect symbols.");
            char letter = str[j] - 'a';
            if (node->nxt[letter] == NULL) {
                node->nxt[letter] = new Node();
            }
            node = node->nxt[letter];
            if (j == str.size() - 1) {
                node->ends.push_back(i);
            }
        }
    }

    ensuref(sz <= MAX_LEN, "Too many letters %d.", sz);

    dfs(root);

    ensuref((int)ans_.size() == n, "Incorrect input.");

    inf.readEof();

    return 0;
}